(*pp camlp4o *)
(* OCamlMakefile requires the above in order to use camlp4o *)
open Format
open Genlex

let fprint_list pr ppf = function
  | [] -> fprintf ppf "[]"
  | x :: xs ->
      let f ppf = List.iter (fun x -> fprintf ppf ";@ %a" pr x) xs in
      fprintf ppf "@[<1>[%a%t]@]" pr x f;;	   
  
let lexer = make_lexer ["["; "]"; ";"]  

let rec parse_U = parser
  | [< 'Kwd ";"; 'Int n; ns = parse_U >] -> n :: ns
  | [< >] -> []

let parse_T = parser
  | [< 'Int n; ns = parse_U; >] -> n :: ns
  | [< >] -> []

let parse_S = parser
  | [< 'Kwd "["; list = parse_T; 'Kwd "]" >] -> list

let parse = parse_S

let read_from_channel ch =
  parse (lexer (Stream.of_channel ch))

let sum list = List.fold_left (+) 0 list

let () = 
  let in_channel = open_in Sys.argv.(1) in
  let list = read_from_channel in_channel in
  close_in in_channel;
  printf "sum %a = %d\n" (fprint_list pp_print_int) list (sum list)
